
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.MorphingRefinment &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.MorphingRefinment</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">import</span> <span class="nn">phaser_wrapper</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="MorphingRefinment_exception"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment_exception">[docs]</a><span class="k">class</span> <span class="nc">MorphingRefinment_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">MorphingRefinment_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="MorphingRefinment"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment">[docs]</a><span class="k">class</span> <span class="nc">MorphingRefinment</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;PrepareMR&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.MorphingRefinment {</span>

<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; Performs a phenix.morphing refinement of each model in the ensemble composing a partial or complete solution for the molecular replacement.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;MorphingRefinment&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">MorphingRefinment</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>
        
        
<div class="viewcode-block" id="MorphingRefinment.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">copy</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;copy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;pdb_structure&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">any_file</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.file_reader&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;any_file&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;shutil&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">np</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;numpy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;time&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">shlex</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;shlex&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">subprocess</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;subprocess&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">phenix_commandline</span> <span class="o">=</span>  <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;phenix.command_line&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;morph_model&quot;</span><span class="p">])</span>

        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="MorphingRefinment.test"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="MorphingRefinment.help"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="MorphingRefinment.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="MorphingRefinment.run"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">MorphingRefinment_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span><span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">morphing_refinement</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="MorphingRefinment.morphing_refinement"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.morphing_refinement">[docs]</a>    <span class="k">def</span> <span class="nf">morphing_refinement</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span> <span class="n">root</span> <span class="o">=</span> <span class="p">[</span><span class="n">root</span><span class="p">]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">&lt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">MorphingRefinment_exception</span><span class="p">(</span><span class="s2">&quot;This action cannot be the root of a PhaserDAG&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">accepted_errors</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">SOLVED_LLG</span> <span class="o">=</span> <span class="mi">80</span>

        <span class="n">return_nodes</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="n">mtz</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">reflections</span>
        <span class="k">if</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">i</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">sigi</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">True</span>
        <span class="k">elif</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">f</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">labin</span><span class="o">.</span><span class="n">sigf</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">False</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">lab_if</span> <span class="o">=</span> <span class="s2">&quot;I&quot;</span>
            <span class="n">lab_sigif</span> <span class="o">=</span> <span class="s2">&quot;SIGI&quot;</span>
            <span class="n">intensities</span> <span class="o">=</span> <span class="kc">True</span>

        <span class="k">for</span> <span class="n">ele</span> <span class="ow">in</span> <span class="n">root</span><span class="p">:</span>
            <span class="n">basedir</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span><span class="o">.</span><span class="n">create_directory_timestamp</span><span class="p">(</span><span class="s2">&quot;morphing_&quot;</span><span class="p">)</span>
            <span class="n">datanode</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_hkl_data</span><span class="p">(</span><span class="n">ele</span><span class="p">)</span>
            <span class="n">solutionodep</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_pdb_model</span><span class="p">(</span><span class="n">ele</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;mr_solution&quot;</span><span class="p">,</span>
                                                                               <span class="n">label_start_with</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">solutionode</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">solutionodep</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionpdbnode</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">([</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">descendants</span><span class="p">(</span><span class="n">solutionode</span><span class="p">)</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">x</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;pdb&quot;</span><span class="p">],</span>
                   <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">c</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">c</span><span class="p">)[</span><span class="s2">&quot;probability&quot;</span><span class="p">],</span> <span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>

            <span class="c1"># print(sorted([(x, self.voyager_dag.nodes(x)[&quot;probability&quot;], self.voyager_dag.nodes(x)[&quot;label&quot;]) for x in self.voyager_dag.descendants(solutionode) if self.voyager_dag.nodes(x)[&quot;type&quot;] == &quot;pdb&quot;],</span>
            <span class="c1">#        key=lambda c: c[1], reverse=True))</span>
            <span class="c1"># print(&quot;SELECTED FOR MORPHING&quot;,solutionpdbnode,self.voyager_dag.nodes(solutionpdbnode)[&quot;label&quot;])</span>
            <span class="c1">#self.schedule_edit_node(solutionpdbnode, label=&quot;aaaaaaaaaaaa&quot;)</span>

            <span class="n">solutionode</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">solutionpdbnode</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">basellg</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">solutionpdbnode</span><span class="p">)[</span><span class="s2">&quot;probability&quot;</span><span class="p">]</span>
            <span class="n">solutionpdbmtz</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">solutionpdbnode</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">],</span> <span class="n">where</span><span class="o">=</span><span class="n">basedir</span><span class="p">)</span>
            <span class="n">solutionpdb</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.pdb&quot;</span><span class="p">)][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">solutionmtz</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">solutionpdbmtz</span> <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s2">&quot;.mtz&quot;</span><span class="p">)]</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">solutionmtz</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">solutionmtz</span> <span class="o">=</span> <span class="n">solutionmtz</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">solutionmtz</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">dictiosol</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">solutionode</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">]</span>

            <span class="k">if</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;llg&quot;</span><span class="p">]</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">newpdbmorph</span><span class="p">,</span> <span class="n">newmtzmorph</span><span class="p">,</span> <span class="n">illg</span><span class="p">,</span> <span class="n">izscore</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">perform_morphing_refinement</span><span class="p">(</span><span class="n">solutionpdb</span><span class="p">,</span> <span class="n">solutionmtz</span><span class="p">,</span> <span class="n">basedir</span><span class="p">,</span> <span class="n">mtz</span><span class="p">,</span> <span class="n">lab_if</span><span class="p">,</span> <span class="n">lab_sigif</span><span class="p">,</span> <span class="n">intensities</span><span class="p">,</span> <span class="n">dictiosol</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">newpdbmorph</span> <span class="o">=</span> <span class="kc">None</span>

            <span class="k">if</span> <span class="n">newpdbmorph</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">illg</span> <span class="o">&gt;</span> <span class="n">basellg</span><span class="p">:</span>
                <span class="n">n</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_model</span><span class="p">([</span><span class="n">newpdbmorph</span><span class="p">,</span> <span class="n">newmtzmorph</span><span class="p">],</span> <span class="s2">&quot;morphing::&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%.1f</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">illg</span><span class="p">),</span>
                                                 <span class="p">{</span><span class="s2">&quot;zscore&quot;</span><span class="p">:</span> <span class="n">izscore</span><span class="p">,</span> <span class="s2">&quot;llg&quot;</span><span class="p">:</span> <span class="n">illg</span><span class="p">,</span>  <span class="s2">&quot;mw&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">],</span> <span class="s2">&quot;nc&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">],</span> <span class="s2">&quot;spacegroup&quot;</span><span class="p">:</span><span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">]},</span> <span class="n">solutionode</span><span class="p">,</span>
                                                 <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">probability</span><span class="o">=</span><span class="n">illg</span><span class="p">,</span> <span class="n">rank</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">solution</span><span class="o">=</span><span class="kc">True</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">return_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">n</span><span class="p">)</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">rmtree</span><span class="p">(</span><span class="n">basedir</span><span class="p">)</span>

        <span class="c1">#if os.path.exists(&quot;MORPH_MODEL_1&quot;): self.shutil.rmtree(&quot;MORPH_MODEL_1&quot;)</span>
        <span class="c1">#if os.path.exists(&quot;morph_model_params.eff&quot;): self.os.remove(&quot;morph_model_params.eff&quot;)</span>

        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">return_nodes</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">root</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">return_nodes</span></div>


<div class="viewcode-block" id="MorphingRefinment.perform_morphing_refinement"><a class="viewcode-back" href="../../../Voyager.Actions.MorphingRefinment.html#Voyager.Actions.MorphingRefinment.MorphingRefinment.perform_morphing_refinement">[docs]</a>    <span class="k">def</span> <span class="nf">perform_morphing_refinement</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">best_pdb</span><span class="p">,</span> <span class="n">best_map</span><span class="p">,</span> <span class="n">basedir</span><span class="p">,</span> <span class="n">mtz</span><span class="p">,</span> <span class="n">lab_if</span><span class="p">,</span> <span class="n">lab_sigif</span><span class="p">,</span> <span class="n">intensities</span><span class="p">,</span> <span class="n">dictiosol</span><span class="p">):</span>
        <span class="n">label1</span> <span class="o">=</span> <span class="n">lab_if</span>
        <span class="n">label2</span> <span class="o">=</span> <span class="n">lab_sigif</span>

        <span class="n">inputs</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;workingdir&quot;</span><span class="p">:</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;jobname&quot;</span><span class="p">:</span> <span class="s2">&quot;morphing&quot;</span><span class="p">,</span> <span class="s2">&quot;mtz&quot;</span><span class="p">:</span> <span class="n">mtz</span><span class="p">,</span> <span class="s2">&quot;mw&quot;</span><span class="p">:</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">],</span> <span class="s2">&quot;nc&quot;</span><span class="p">:</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">],</span> <span class="s2">&quot;I-F&quot;</span><span class="p">:</span> <span class="n">label1</span><span class="p">,</span>
                  <span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">:</span> <span class="n">label2</span><span class="p">,</span>
                  <span class="s2">&quot;intensities&quot;</span><span class="p">:</span> <span class="n">intensities</span><span class="p">,</span> <span class="s2">&quot;mute&quot;</span><span class="p">:</span> <span class="kc">True</span><span class="p">,</span> <span class="s2">&quot;new_spacegroup&quot;</span><span class="p">:</span> <span class="n">dictiosol</span><span class="p">[</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">],</span>
                  <span class="s2">&quot;sol&quot;</span><span class="p">:</span> <span class="p">[]}</span>

        <span class="n">reflections</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_DAT</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">reflections</span>

        <span class="n">ensemble_morphed</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;morphed.pdb&quot;</span><span class="p">)</span>

        <span class="n">remarks1</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">best_pdb</span><span class="p">)</span><span class="o">.</span><span class="n">remarks</span>

        <span class="n">solufixs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">extract_single_components_from_solution</span><span class="p">(</span><span class="n">best_pdb</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">prepare</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;prepare&quot;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">prepare</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">prepare</span>
        <span class="k">for</span> <span class="n">nnx</span><span class="p">,</span> <span class="n">fx</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">solufixs</span><span class="p">):</span>
            <span class="n">ppp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">fx</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">w</span><span class="p">,</span> <span class="n">model</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">ppp</span><span class="o">.</span><span class="n">structure</span><span class="p">):</span>
                <span class="n">pdbf</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">prepare</span><span class="p">,</span> <span class="s2">&quot;fx&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">nnx</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;.pdb&quot;</span><span class="p">)</span>
                <span class="n">ppp</span><span class="o">.</span><span class="n">get_pdb_from_list_of_atoms</span><span class="p">(</span><span class="n">extract_only_models</span><span class="o">=</span><span class="p">[</span><span class="n">w</span><span class="p">],</span> <span class="n">write_pdb</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                                               <span class="n">path_output_pdb</span><span class="o">=</span><span class="n">pdbf</span><span class="p">)</span>
                <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">({</span><span class="s2">&quot;modlid&quot;</span><span class="p">:</span> <span class="s2">&quot;fx&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">nnx</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;.pdb&quot;</span><span class="p">,</span> <span class="s2">&quot;pdb&quot;</span><span class="p">:</span> <span class="n">pdbf</span><span class="p">,</span> <span class="s2">&quot;identity&quot;</span><span class="p">:</span> <span class="mf">1.0</span><span class="p">})</span>
                <span class="k">break</span>

        <span class="n">result</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_RNP</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">llg</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;SHIFT: Single model of multi ensembles, llg&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">llg</span><span class="p">))</span>
        <span class="n">solutionpdb</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basedir</span><span class="p">,</span> <span class="s2">&quot;modelformorphing.pdb&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="n">result</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">(),</span> <span class="n">best_pdb</span><span class="p">)</span>
        
        <span class="c1"># command_line = &quot;phenix.morph_model data=&quot; + str(best_map) + &quot; model=&quot; + str(best_pdb) + &quot; morphed_model=&quot; + str(ensemble_morphed) + &quot; number_of_cycles=2&quot;</span>
        <span class="c1"># args = self.shlex.split(command_line)</span>
        <span class="c1"># p = self.subprocess.Popen(args, stdin=self.subprocess.PIPE, stdout=self.subprocess.PIPE, stderr=self.subprocess.PIPE)</span>
        <span class="c1"># outp, errp = p.communicate()</span>
        <span class="c1"># print(outp)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">phenix_commandline</span><span class="o">.</span><span class="n">morph_model</span><span class="o">.</span><span class="n">morph_model</span><span class="p">(</span><span class="n">args</span><span class="o">=</span><span class="p">[</span><span class="n">best_map</span><span class="p">,</span> <span class="n">best_pdb</span><span class="p">,</span> <span class="s2">&quot;morphing.number_of_cycles=2&quot;</span><span class="p">,</span> <span class="s2">&quot;morphed_model=&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">ensemble_morphed</span><span class="p">)),</span> <span class="s2">&quot;directories.workdir=&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">basedir</span><span class="p">)),</span> <span class="s2">&quot;directories.temp_dir=&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">basedir</span><span class="p">),</span> <span class="s2">&quot;temp_dir&quot;</span><span class="p">))])</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">ensemble_morphed</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;imported_fp_sigfp_freer.mtz&quot;</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;imported_fp_sigfp_freer.mtz&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;morph_model_params.eff&quot;</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;morph_model_params.eff&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;morph_cycle_1_001.pdb&quot;</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;morph_cycle_1_001.pdb&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;map_coeffs_1.mtz&quot;</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;map_coeffs_1.mtz&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;map_coeffs_2.mtz&quot;</span><span class="p">):</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;map_coeffs_2.mtz&quot;</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="s2">&quot;morph_cycle_2_001.pdb&quot;</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">shutil</span><span class="o">.</span><span class="n">copyfile</span><span class="p">(</span><span class="s2">&quot;morph_cycle_2_001.pdb&quot;</span><span class="p">,</span> <span class="n">ensemble_morphed</span><span class="p">)</span>
                <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s2">&quot;morph_cycle_2_001.pdb&quot;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">ensemble_morphed</span><span class="p">):</span>
            <span class="n">st2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">pdb_structure</span><span class="o">.</span><span class="n">PDB</span><span class="p">(</span><span class="n">ensemble_morphed</span><span class="p">)</span>
            <span class="n">st2</span><span class="o">.</span><span class="n">get_pdb_from_list_of_atoms</span><span class="p">(</span><span class="n">write_pdb</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">path_output_pdb</span><span class="o">=</span><span class="n">st2</span><span class="o">.</span><span class="n">filepath</span><span class="p">,</span>
                                           <span class="n">header</span><span class="o">=</span><span class="n">remarks1</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">st2</span><span class="o">.</span><span class="n">remarks</span><span class="p">)</span>

            <span class="c1"># TODO: How to establish what should be the identity of the rms here? shift field</span>
            <span class="c1"># have moved the things so how we should establish the correct new value?</span>
            <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[{</span><span class="s2">&quot;modlid&quot;</span><span class="p">:</span> <span class="s2">&quot;morphed&quot;</span><span class="p">,</span> <span class="s2">&quot;pdb&quot;</span><span class="p">:</span> <span class="n">ensemble_morphed</span><span class="p">,</span> <span class="s2">&quot;identity&quot;</span><span class="p">:</span><span class="mf">1.0</span><span class="p">}]</span>

            <span class="n">result</span> <span class="o">=</span> <span class="n">phaser_wrapper</span><span class="o">.</span><span class="n">start_MR_RNP</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">llg</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;MORPHING: RNP OF &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">ensemble_morphed</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; llg &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">llg</span><span class="p">))</span>
            <span class="n">zscore</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopTFZ</span><span class="p">()</span>
            <span class="k">return</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">(),</span> <span class="n">result</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">()[:</span><span class="o">-</span><span class="mi">4</span><span class="p">]</span> <span class="o">+</span> <span class="s2">&quot;.mtz&quot;</span><span class="p">,</span> <span class="n">llg</span><span class="p">,</span> <span class="n">zscore</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span><span class="p">,</span><span class="kc">None</span></div></div>

</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>